Bug 1578612 - Bluetooth randomly stutters
Summary: Bluetooth randomly stutters
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 28
Hardware: x86_64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-05-16 02:09 UTC by SlayerProof32
Modified: 2019-10-24 02:54 UTC (History)
22 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-05-28 23:24:37 UTC
Type: Bug
korbin.freedman: needinfo-


Attachments (Terms of Use)
Dmesg after boot (74.99 KB, text/plain)
2018-05-19 16:41 UTC, SlayerProof32
no flags Details

Description SlayerProof32 2018-05-16 02:09:56 UTC
Description of problem:


Version-Release number of selected component (if applicable):


How reproducible:
frequently


Steps to Reproduce:
1.Fire up lenovo t410 with fedora 28. (Only device i've tested this bug on)
2.Connect bluetooth headphones
3.Do something with it, and bluetooth will stutter

Actual results:
Bluetooth randomly stutters frequently


Expected results:
No bluetooth stutter


Additional info: This dmesg section might have to do with this problem
Tested bug on Lenovo t410
Bluetooth device from lspci
Bus 001 Device 010: ID 0a5c:217f Broadcom Corp. BCM2045B (BDC-2.1)



[56787.991959] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56802.989982] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56817.994065] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56832.992977] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56847.992980] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56862.994053] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56877.989013] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56892.994031] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56907.994021] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56922.992026] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56937.994167] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56952.992024] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56963.457057] Bluetooth: hci0: SCO packet for unknown connection handle 6
[56963.457065] Bluetooth: hci0: SCO packet for unknown connection handle 6
[56963.457067] Bluetooth: hci0: SCO packet for unknown connection handle 6
[56967.992116] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56982.989041] Bluetooth: hci0: last event is not cmd complete (0x0f)
[56997.994050] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57012.994054] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57027.994069] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57042.993134] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57057.994222] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57072.994146] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57087.993080] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57102.994094] Bluetooth: hci0: last event is not cmd complete (0x0f)
[57117.994118] Bluetooth: hci0: last event is not cmd complete (0x0f)

Comment 1 Illya 2018-05-16 09:33:15 UTC
I have similar dmesg logs wenn I try to establish a (network) connection to my ebook:


> [30631.946945] Bluetooth: hci0: last event is not cmd complete (0x0f)
> [30646.944856] Bluetooth: hci0: last event is not cmd complete (0x0f)
> [30661.945037] Bluetooth: hci0: last event is not cmd complete (0x0f)
> [30676.944661] Bluetooth: hci0: last event is not cmd complete (0x0f)


It seems to be kernel bluetooth bug and not pulseaudio:

https://bugzilla.kernel.org/show_bug.cgi?id=198699

Comment 2 SlayerProof32 2018-05-18 01:19:18 UTC
This does appear to be a kernel issue. Updated component name. (Sorry pulseaudio, you are not the problem). The bluetooth issue seems to force the kernel to lower it's max sample rate.

See dmesg paste Notice the interrupt took too long message 3 times. I have only had this computer booted for 15 minutes so far.


[  670.405527] perf: interrupt took too long (2513 > 2500), lowering kernel.perf_event_max_sample_rate to 79000
[  670.757845] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  685.755860] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  700.754831] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  715.756845] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  730.757909] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  742.359597] perf: interrupt took too long (3158 > 3141), lowering kernel.perf_event_max_sample_rate to 63000
[  745.754977] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  760.757940] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  775.755903] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  790.757974] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  805.757901] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  820.756913] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  835.757968] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  850.756955] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  865.758022] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  880.757979] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  895.758041] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  910.757952] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  925.755996] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  940.755015] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  955.757951] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  970.756006] Bluetooth: hci0: last event is not cmd complete (0x0f)
[  985.757990] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1000.756061] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1015.758089] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1030.756041] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1045.757042] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1047.573279] perf: interrupt took too long (3954 > 3947), lowering kernel.perf_event_max_sample_rate to 50000

Comment 3 Hans de Goede 2018-05-18 08:16:26 UTC
Can you please run:

dmesg > dmesg.log

Shortly after a boot and attach the output here?

Likely you will find a message about missing firmware for the bluetooth in there. If the bluetooth part of your wifi/bt combo card is USB based (it likely is) you can find firmware files for it here:
https://github.com/winterheart/broadcom-bt-firmware

Please try putting a firmware file from there (with the right name) under /lib/firmware/brcm and then reboot. Please do a second:

dmesg > dmesg2.log

After the reboot with the firmware in place and also check if this fixes things.

Comment 4 SlayerProof32 2018-05-18 19:42:28 UTC
$ dmesg | grep firmware

[    2.443657] psmouse serio2: trackpoint: IBM TrackPoint firmware: 0x0e, buttons: 3/3
[   16.070764] iwlwifi 0000:03:00.0: Direct firmware load for iwlwifi-6000-6.ucode failed with error -2
[   16.070799] platform regulatory.0: Direct firmware load for regulatory.db failed with error -2
[   16.073453] iwlwifi 0000:03:00.0: Direct firmware load for iwlwifi-6000-5.ucode failed with error -2
[   16.235832] iwlwifi 0000:03:00.0: loaded firmware version 9.221.4.1 build 25532 op_mode iwldvm
[ 8753.543041] usb 2-1.1: device firmware changed

This is what I get when I run Dmesg | grep firmware
Does IWLwifi have to do with the broadcom bluetooth chip?

Comment 5 SlayerProof32 2018-05-19 01:33:03 UTC
https://askubuntu.com/questions/41778/computer-freezing-on-almost-full-ram-possibly-disk-cache-problem

https://unix.stackexchange.com/questions/28175/system-hanging-when-it-runs-out-of-memory

https://bbs.archlinux.org/viewtopic.php?id=231087

Over 5 (Non bug reporting) websites report this bug, with recent posts up to 2018. This memory issue is FATAL to people who rely on linux for gaming/working. Please don't let this issue go unnoticed for 11 more years. It is critical to system function that memory management is good. The issue actually doesn't only occur when swapping. Swapping however greatly aggravates this bug

Comment 6 SlayerProof32 2018-05-19 01:35:11 UTC
Ignore comment 5. That has to do with another bug. I posted in the wrong place. Sorry

Comment 7 Hans de Goede 2018-05-19 12:03:07 UTC
(In reply to SlayerProof32 from comment #4)
> $ dmesg | grep firmware
> 
> [    2.443657] psmouse serio2: trackpoint: IBM TrackPoint firmware: 0x0e,
> buttons: 3/3
> [   16.070764] iwlwifi 0000:03:00.0: Direct firmware load for
> iwlwifi-6000-6.ucode failed with error -2
> [   16.070799] platform regulatory.0: Direct firmware load for regulatory.db
> failed with error -2
> [   16.073453] iwlwifi 0000:03:00.0: Direct firmware load for
> iwlwifi-6000-5.ucode failed with error -2
> [   16.235832] iwlwifi 0000:03:00.0: loaded firmware version 9.221.4.1 build
> 25532 op_mode iwldvm
> [ 8753.543041] usb 2-1.1: device firmware changed
> 
> This is what I get when I run Dmesg | grep firmware
> Does IWLwifi have to do with the broadcom bluetooth chip?

No, I'm a bit surprised that your laptop has iwlwifi combined with a broadcom bluetooth chip, usually both are the same.

Either way please attach full dmesg from directly after boot (as requested before).

Comment 8 SlayerProof32 2018-05-19 16:41:51 UTC
Created attachment 1438941 [details]
Dmesg after boot

Comment 9 SlayerProof32 2018-05-19 16:47:38 UTC
I just found which broadcom chip i'm using. This may help

Bus 001 Device 006: ID 0a5c:217f Broadcom Corp. BCM2045B (BDC-2.1)

Comment 10 SlayerProof32 2018-05-19 16:55:26 UTC
The winterheart github doesnt have the correct drivers for this chip

Comment 11 Hans de Goede 2018-05-19 20:26:29 UTC
(In reply to SlayerProof32 from comment #10)
> The winterheart github doesnt have the correct drivers for this chip

Yes, it looks like this chip does not have patchram support.

Looking at other entries for the BCM2045 IC in the btusb driver, it looks like you may need to add a quirk.

Can you please try adding:

"btusb.force_scofix=1"

To your kernel commandline.

After reboot, make sure it really is there by doing:

cat /proc/cmdline

And then check if bluetooth now works better.

Comment 12 SlayerProof32 2018-05-20 17:17:23 UTC
Thanks for the suggestion, but that did not fix the issue. Anything else I would try, or logs you want?

Comment 13 Hans de Goede 2018-05-21 12:26:12 UTC
Hi,

(In reply to SlayerProof32 from comment #12)
> Thanks for the suggestion, but that did not fix the issue. Anything else I
> would try, or logs you want?

I'm sorry, but nothing comes to mind. It is probably best to send a bug-report upstream by email to: linux-bluetooth@vger.kernel.org

Regards,

Hans

Comment 14 SlayerProof32 2018-05-23 01:33:59 UTC
There appears to already be a bug report upstream as @ILLYA (comment 1) states

Comment 15 SlayerProof32 2018-06-03 19:36:32 UTC
It seems as though the latest IWLwifi drivers have partially fixed the issue

Comment 16 Laura Abbott 2018-10-01 21:18:24 UTC
We apologize for the inconvenience.  There is a large number of bugs to go through and several of them have gone stale.  Due to this, we are doing a mass bug update across all of the Fedora 28 kernel bugs.
 
Fedora 28 has now been rebased to 4.18.10-300.fc28.  Please test this kernel update (or newer) and let us know if you issue has been resolved or if it is still present with the newer kernel.
 
If you have moved on to Fedora 29, and are still experiencing this issue, please change the version to Fedora 29.
 
If you experience different issues, please open a new bug report for those.

Comment 17 Tore H. Larsen 2018-11-05 07:35:37 UTC
cc. Running Fedora 29 4.18.16-300.fc29.x86_64 and problem remains.

[    5.524906] iwlwifi 0000:3b:00.0: loaded firmware version 38.755cfdd8.0 op_mode iwlmvm
[    5.619210] iwlwifi 0000:3b:00.0: Detected Intel(R) Dual Band Wireless AC 9260, REV=0x324
[    6.690595] Bluetooth: hci0: Found device firmware: intel/ibt-18-16-1.sfi
[ 1045.732952] Bluetooth: hci0: last event is not cmd complete (0x0f)
[ 1047.955918] Bluetooth: hci0: SCO packet for unknown connection handle 0

Also, present after connecting a device to the laptop, such as cell phone and BT mouse.

Comment 18 Wim Taymans 2018-12-03 09:17:59 UTC
FWIW, I have stuttering issues when I use bluetooth and have the control center open (where I connected the bluetooth device).

As soon as I close the control center things are back to normal and stuttering doesn't happen anymore.

I suspect the scanning + streaming does not go well together on my hardware. Maybe you have the same issue?

Comment 19 Ben Cotton 2019-05-02 20:11:23 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 20 Ben Cotton 2019-05-28 23:24:37 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.